/* 
* Rootfly:  A program for analyzing and measuring roots. 
* Copyright (c) 2007 Clemson University.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or (at
* your option) any later version.
* 
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 


// RootflyDlg.h : header file
//

#if !defined(AFX_ROOTFLYDLG_H__9A207D0A_EA9D_4383_94FC_96302A1E054F__INCLUDED_)
#define AFX_ROOTFLYDLG_H__9A207D0A_EA9D_4383_94FC_96302A1E054F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#define ID_INDICATOR_STATUS 104
//#define ID_INDICATOR_PIXEL 106
#define SELECTED_THUMBNAIL_BORDER_WIDTH 3 

/////////////////////////////////////////////////////////////////////////////
// CRootflyDlg dialog

#include "Controller.h"
#include "DataStructures.h"
#include "MemDC.h"
#include "ImageFileFormat.h" // temporary until set up with Controller -msb
#include "ImageClientConverter.h"
#include "SessionDatesDlg.h"
#include "RootflyGraphics.h"
#include "ProgressData.h"	// Added by ClassView
#include "ModeHandler.h"
#include "RootflyStatusBar.h"
#include "TestBar.h"

/**@class CRootflyDlg
\brief This class contains instances of every control on the dialog box and function declarations for all the controls.
*/
class CRootflyDlg : public CDialog, public Observer
{
  // Construction
public:
  CRootflyDlg(CWnd* pParent = NULL);	// standard constructor
  ~CRootflyDlg();
  RootflyStatusBar Status_bar;  //Status bar instance
  //CDialogBar not functional
  //TestBar m_test_bar;				//CDialogBar example

  void MyZoomIn();
  void MyZoomOut();

  // Dialog Data
  //{{AFX_DATA(CRootflyDlg)
	enum { IDD = IDD_ROOTFLY_DIALOG };
	CButton	m_button_zoomout;
	CButton	m_button_zoomin;
	CButton	m_button_downzoom;
	CButton	m_button_leftzoom;
	CButton	m_button_rightzoom;
	CButton	m_button_upzoom;
//	CButton	m_button_auto_detect;
	CButton m_button_annotate;
	CButton	m_check_zoom_in;
	CStatic	m_status_text;
  CButton	m_button_move_all_roots;
  CButton	m_check_zoom_out;
  CComboBox	m_combo_color;
  CStatic	m_mm_text;
  CStatic	m_session_date5;
  CStatic	m_session_date4;
  CStatic	m_session_date3;
  CStatic	m_session_date2;
  CStatic	m_session_date1;
  CScrollBar	m_test_scroll;
  CStatic	m_root_id_text;
  CButton	m_color_section;
  CButton	m_button_delete_root;
  CButton	m_button_copy;
  CButton	m_button_extend_endpoints;
  CButton	m_button_new_root;
  CStatic	m_color_text;
  CStatic	m_length_text;
  CStatic	m_session_text;
  CStatic	m_custom_text;
  CStatic	m_diameter_text;
  CStatic	m_state_text;
  CStatic	m_tube_text;
  CStatic	m_window_text;
  CButton	m_color_box;
  CButton	m_properties_section;
  CButton	m_session_section;
  CButton	m_images_section;
  CButton	m_window_section;	
  CStatic	m_color_chart;
  CButton	m_checkbox_show_root_ids;
  CButton	m_checkbox_show_diameters;
  CButton	m_checkbox_show_dead_roots;
  CScrollBar	m_scrollbar_horizontal;
  CScrollBar	m_scrollbar_vertical;
  CStatic	m_static_color;
  CButton	m_New_Root;
  CButton	m_Extend_Endpoints;
  CButton	m_Delete_Root;
  CButton	m_Copy;
  CButton	m_Add_Diameter;
  CStatic	m_Window_Pic_1;
  CStatic	m_Window_Pic_2;
  CStatic	m_Window_Pic_3;
  CStatic	m_Window_Pic_4;
  CStatic	m_Window_Pic_5;
  CStatic	m_Session_Pic_1;
  CStatic	m_Session_Pic_2;
  CStatic	m_Session_Pic_3;
  CStatic	m_Session_Pic_4;
  CStatic	m_Session_Pic_5;
  CEdit	m_edit_tube;
  CEdit	m_edit_window;
  CEdit	m_edit_transect;
  CSpinButtonCtrl	m_spin_tube;
  CSpinButtonCtrl	m_spin_window;
  CSpinButtonCtrl	m_spin_session;
  CEdit	m_edit_rootid;
  CEdit	m_edit_diameter;
  CEdit	m_edit_length;
  CComboBox	m_combo_state;
  CComboBox	m_combo_custom;
  CButton	m_register_control;
  CEdit	m_edit_session;
  BOOL	m_Show_Dead_Roots;
  BOOL	m_Show_Diameters;
  BOOL	m_Show_Root_IDs;
  BOOL  is_Zoomed_Out;
  CString	m_session_date_text;
  CString	m_session_date_3;
	//}}AFX_DATA
  
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CRootflyDlg)
protected:
  virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
  //}}AFX_VIRTUAL
  
  virtual void OnUpdate(Subject* theChangeSubject, int code_update);
  
  // Implementation
protected:
  HICON m_hIcon;
  //int DialogGUIstate;
  //CToolBar m_wndToolBar; //Hide toolbar
  
  // Generated message map functions
  //{{AFX_MSG(CRootflyDlg)
  virtual BOOL OnInitDialog();
  afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
  afx_msg void OnPaint();
  afx_msg HCURSOR OnQueryDragIcon();
  afx_msg void OnBUTTONNewRoot();
  afx_msg void OnBUTTONExtendEndpoints();
  afx_msg void OnBUTTONDeleteRoot();
  afx_msg void OnFileExit();
  afx_msg void OnFileNew();
  afx_msg void OnFileOpen();
  afx_msg void OnFileSaveAs();
  afx_msg void OnFileSave();
  afx_msg void OnEditImageFileFormat();
  afx_msg void OnHelpAbout();
  afx_msg void OnLButtonDown  (UINT nFlags, CPoint point);
  afx_msg void OnLButtonUp    (UINT nFlags, CPoint point);
  afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
  afx_msg void OnRButtonDown  (UINT nFlags, CPoint point);  
  afx_msg void OnRButtonUp    (UINT nFlags, CPoint point);  
  afx_msg void OnMouseMove(UINT nFlags, CPoint point);
  afx_msg void OnSize(UINT nType, int cx, int cy);
  afx_msg void OnSizeNew(UINT nType,int cx, int cy);
  afx_msg void Rootfly_Right_Objects_Hide();
  afx_msg void Rootfly_Left_Objects_Hide();
  afx_msg void Rootfly_Bottom_Objects_Hide();
  afx_msg void OnHelpContents();
  virtual void OnOK();
  virtual void OnCancel();
  afx_msg void OnKillfocusEditDiameter();
  afx_msg void OnKillfocusEditSession();
  afx_msg void OnKillfocusEditWindow();
  afx_msg void OnKillfocusEditTube();
  afx_msg void OnDeltaposSpinTube(NMHDR* pNMHDR, LRESULT* pResult);
  afx_msg void OnDeltaposSpinSession(NMHDR* pNMHDR, LRESULT* pResult);
  afx_msg void OnDeltaposSpinWindow(NMHDR* pNMHDR, LRESULT* pResult);	
  afx_msg void OnCHECKShowRootIDs();
  afx_msg void OnCHECKShowDeadRoots();
  afx_msg void OnCHECKShowDiameters();
  afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
  afx_msg void OnFileExport();
  afx_msg void OnClose();
  afx_msg void OnConversion();
  afx_msg void OnSelchangeComboColor();
  afx_msg void OnSelchangeComboCustom();
  afx_msg void OnSelchangeComboState();
  afx_msg void OnButtonMoveAllRoots();
  afx_msg void OnDropdownComboCustom();
  afx_msg void OnKillfocusComboCustom();
  afx_msg void OnCondition();
  afx_msg void OnEditChangeImgDir();
  afx_msg void OnEditColors();
  afx_msg void OnEditSessionDates();
  afx_msg void OnDeletePoint();
  afx_msg void OnAddPoint();
  afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
  afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
  afx_msg void OnDebugResetmode();
  afx_msg void OnDebugDisplayrootdata();
  afx_msg void OnDebugRepairdiameter();
  afx_msg void OnDebugShowdebuglogfilelocation();
  afx_msg void OnNavigateProgresswindow();
  afx_msg void OnEditZoom();
  afx_msg void OnEditZoomOut();
  afx_msg void OnEditZoomIn();
	afx_msg void OnUpdateViewRightpane(CCmdUI* pCmdUI);
	afx_msg void OnEditUndo();
	afx_msg void OnEditRedo();
	afx_msg void OnEditAutodetect();
	afx_msg void OnUpdateViewLeftpane(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewBottompane(CCmdUI* pCmdUI);
	afx_msg void OnDoneAnnotating();
	afx_msg void OnKeyboardLeftzoom();
	afx_msg void OnKeyboardDownzoom();
	afx_msg void OnKeyboardUpzoom();
	afx_msg void OnKeyboardRightzoom();
	afx_msg void OnButtonUpzoom();
	afx_msg void OnButtonLeftzoom();
	afx_msg void OnButtonRightzoom();
	afx_msg void OnButtonDownzoom();
	afx_msg void OnBUTTONZoomIn();
	afx_msg void OnBUTTONZoomOut();
	afx_msg void OnBUTTONAnnotate();
	afx_msg void OnEditAutodetectroots();
	afx_msg void OnEditCopysession();
	//}}AFX_MSG
  DECLARE_MESSAGE_MAP()

// The variables and methods below are public so that ModeHandlerFactory,
// ModeHandler, and derived classes can access them.  A better way would
// be to pull these variables and methods out of RootflyDlg and put them 
// into ApplicationData, then to pass a Controller* into the ModeHandler.  
// But this is okay for now, because we need to make minimal changes at
// each stage of our refactoring to avoid breaking the code. -- STB
public:
  
  Controller m_controller;
  ImageFileFormat m_image_file_format;
  RootflyGraphics m_graphics; 
  ImageClientConverter m_converter;
  int m_shiftx;
  int m_shifty;
  double m_zoomin;

  HCURSOR m_cur_openhand;
  HCURSOR m_cur_closedhand;
  HCURSOR m_cur_uparrow;
  HCURSOR m_cur_sizeall;
  HCURSOR m_cur_sizens;
  HCURSOR m_cur_movepoint;  // move point on root polyline
  HCURSOR m_cur_pen;
  
   
    
  const RootflyData* m_rfy_data;
   
  // mode of the program
  Mode m_mode;  
  
  // true if rootfly filename is valid (used in OnFileSave)
  bool m_first_save;   
  
  void EnableDisable();
  void ReDraw(int main_changed, int update_thumbnails);
    
  CString ChangeFileTube(int new_tube);
  CString ConvertTubeName(CString input);
  CString StripPaddedZeros(CString input);
  CString ChangeFileWindow(int new_window);  
  CString ChangeFileSession(int new_session);
  void UpdateProperties(int selected_root);
  void UpdateThumbnails();
  void UpdateSessionDateText();
  void UpdateMainImage(CDC& dc);
  void UpdateCustomCombo(std::vector<CString> set);
  void RunAutomaticRootDetector(bool button);
  void SetCondition(CString user_code);
  void SetConditionDefault(const Root *root);
  CString GetConditionDefault() const;
  void InitializeConditionSet();
  void ThumbnailClicked(int index, int type);  
  bool CheckForThumbnailClick(CPoint point); 
  CRect GetThumbnailRect(int index, int type);
  bool DrawImage(blepo::ImgBgr img, CRect rect, int selected, CDC& dc) const;  
  void SetZoomWindows();
  bool IsZoomOutMode() const; 
  CRect GetClientRectOfImageDisplayArea() const;  
  void SetMode( Mode new_mode ) { m_mode = new_mode; EnableDisable(); UpdateStatusText(); }
  Mode GetMode() const { return m_mode; }
  void UpdateStatusText();
  void CheckForCommandLine();

  void OnUpArrow();
  void OnDownArrow();
  void OnRightArrow();
  void OnLeftArrow();
  
  void SetNavigation(const CString& directory);
  bool ValidateDirectory(CString* directory);
  void ClearSelection();
 
  RootInstance m_current_root_being_drawn;
  CPoint m_last_mouse_point;
  CPoint m_last_mouse_move_point;  // in image coordinates
  bool m_extending_from_head;
  bool m_extending_from_tail;

  double m_previous_radius_for_undo;
  RPoint m_previous_diam_rpoint_for_undo;
  CPoint m_previous_click_cpoint_for_undo;
  RootInstance m_previous_root_for_undo;

  //////////////////////////////////////////////////////////////////////
  // This section hold data and methods for trigonometric calculation of
  // distances from points to diameters and lines and related structures
  //////////////////////////////////////////////////////////////////////
  
  typedef struct pt2d 
  { 
    double x,y; 
  } pt2d; 
  
  static double CRootflyDlg::DistPt2Seg( pt2d a,pt2d b,pt2d p,pt2d *c);
  static bool CRootflyDlg::IsPtInsideDiameter(int x1, int y1, const RDiameter* diam, int threshold);
//  static double CRootflyDlg::DistPt2Diameter(int x1, int y1, const RDiameter* diam);
  static double CRootflyDlg::DotProduct(pt2d a, pt2d b);

  // This is the ID of the root under the mouse (i.e., the root that will be selected
  // if the left mouse button is clicked).  After clicking (i.e., selecting the root),
  // it remains the ID of the selected root.  -1 means no root selected or under the mouse.
  int m_selected_root_id;
  
  // This is the index of the point (in the selected root) that is under the mouse.
  // It remains the index of this point when the user clicks and drags to move the point.
  // Special values:  -1 means no index, -2 means the center of the diameter, and 
  // -3 means the small rectangle at the top of the diameter that allows the user to
  // resize the diameter. 
  enum SpecialSelection { NOTHING_SELECTED           = -1, 
                          DIAMETER_SELECTED          = -2, 
                          RESIZING_DIAMETER_SELECTED = -3 };
  int m_selected_index;
  double diameter_position_ratio;
  int section_start_point_index;
  RPoint temporary_point_to_add;

  
  // whether the cursor is currently over a root
  bool m_over_root;

  int FindNearestDiameter( int x, int y ) const;
  void FindNearestPoint( int x, int y, RDiameter *temp ) const;
  RPoint FindNearestPointOnRoot(const RPoint& rpoint, const RootInstance& r) const;
  RPoint FindNearestPointOnRootSeg(const RPoint& rpoint, const RootInstance& r, int* segment_start ) const;
  void UpdateDiameterPositionRatio();
  int GetSelectedIndex( CPoint pt ) const;

  ////////////////////////////////////////////////////////////////////////////
  //  End trigonometery and related section
  ////////////////////////////////////////////////////////////////////////////

public:
	void ProgressImageClicked(int window, int tube, int session); 
private:
	void FindAnnotatedRoots();
	ProgressData m_progress_data;
};
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.


#endif // !defined(AFX_ROOTFLYDLG_H__9A207D0A_EA9D_4383_94FC_96302A1E054F__INCLUDED_)

