
#ifndef SESSION_ARRAY_HEADER
#define SESSION_ARRAY_HEADER

//#include "stdafx.h"
#include <string>
#include <vector>

namespace OldData
{

  using std::string;

  struct Date
  {
    int year, month, day;
    Date() : year(-1), month(-1), day(-1) {}
    Date(int yyear, int mmonth, int dday) : year(yyear), month(mmonth), day(dday) {}

    int GetDayOfYear() const;
    int GetDaySince1970() const;

    bool operator<(const Date& other) const
    {
      return (year < other.year
              || (year == other.year
                  && (month < other.month
                      || month == other.month && day < other.day)));
    }

    bool operator>(const Date& other) const
    {
      return (year > other.year
              || (year == other.year
                  && (month > other.month
                      || month == other.month && day > other.day)));
    }

    bool operator==(const Date& other) const
    {
      return (year == other.year && month == other.month && day == other.day);
    }

    void operator++()  // prefix increment ++p
    {

      int month_length[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 30, 31, 31};

      if ((year % 4 == 0) && ((year % 100 != 0) || (year % 400 == 0)))  
      { month_length[1]++;  /* leap year */ }

      day++;

      if(day > month_length[month])
      {
        day = day - month_length[month];
        month++;
        if(month > 12)
        {
          year++;
          month = 1;
        }
      }
    }
    void operator++(int)  // postfix increment p++
    {
      ++(*this);
    }
  };

  // ------------------------------------------------------------------------------------------------

  class Session_Array{

  public:
	  Session_Array();
	  int add_date(const Date& date);
	  Date GetDate(int sessionNumber);

  private:
	  std::vector<Date> dates;
	  int CheckForDate(const Date& date);
	  void SortArray();
  //  int GetDayOfYear(const Date& date);
  //  int GetDayAnnoDomini(const Date& date);
  };
}//namespace OldData

#endif